=== debian/changelog ===
simdjson (0.5.0-2) unstable; urgency=medium

  * Apply wrap-and-sort.
  * Bump debhelper compat level to 13.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 16 Oct 2020 10:33:45 +0800

simdjson (0.5.0-1) experimental; urgency=medium

  * New upstream version 0.5.0
  * Specify build option SIMDJSON_JUST_LIBRARY=ON.
  * SOVERSION bump from 1->3 ; Update package names accordingly.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 17 Sep 2020 19:02:44 +0800

simdjson (0.3.1-1) experimental; urgency=medium

  * New upstream version 0.3.1
  * Remove the merged patches.

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Apr 2020 21:15:26 +0800

simdjson (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0
  * Refresh symbols control file.
  * Update package descriptions
  * Cherry-pick soversion-bumping patch from upstream PR.
  * Bump SOVERSION to 1 and reflect changes in control files.
  * Bump Standards-Version to 4.5.0 (no change).
  * Update my mail address in control and copyright.
  * Bump debhelper compat level to 12.
  * Install the cmake files to the -dev package.
  * Update copyright information.
  * Specify Rules-Requires-Root: no.
  * Refresh symbols control file for arm64.

 -- Mo Zhou <lumin@debian.org>  Wed, 01 Apr 2020 19:20:59 +0800
