=== debian/control ===
Source: simdjson
Section: libs
Homepage: https://github.com/lemire/simdjson
Priority: optional
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian/simdjson
Vcs-Git: https://salsa.debian.org/debian/simdjson.git
Maintainer: Mo Zhou <lumin@debian.org>
Build-Depends: cmake, debhelper-compat (= 13)
Rules-Requires-Root: no

Package: libsimdjson3
Architecture: any-amd64 arm64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Parsing gigabytes of JSON per second (shared object)
 JSON is everywhere on the Internet. Servers spend a *lot* of time parsing it.
 The simdjson library uses commonly available SIMD instructions and
 microparallel algorithms to parse JSON 2.5x faster than anything else out
 there.
 .
 Fast: Over 2.5x faster than other production-grade JSON parsers.
 Easy: First-class, easy to use API.
 Strict: Full JSON and UTF-8 validation, lossless parsing.
         Performance with no compromises.
 Automatic: Selects a CPU-tailored parser at runtime.
            No configuration needed.
 Reliable: From memory allocation to error handling,
           simdjson's design avoids surprises.
 .
 This package ships the shared object.

Package: libsimdjson-dev
Section: libdevel
Architecture: any-amd64 arm64
Depends: libsimdjson3 (= ${binary:Version}), ${misc:Depends}
Description: Parsing gigabytes of JSON per second (development)
 JSON is everywhere on the Internet. Servers spend a *lot* of time parsing it.
 The simdjson library uses commonly available SIMD instructions and
 microparallel algorithms to parse JSON 2.5x faster than anything else out
 there.
 .
 Fast: Over 2.5x faster than other production-grade JSON parsers.
 Easy: First-class, easy to use API.
 Strict: Full JSON and UTF-8 validation, lossless parsing.
         Performance with no compromises.
 Automatic: Selects a CPU-tailored parser at runtime.
            No configuration needed.
 Reliable: From memory allocation to error handling,
           simdjson's design avoids surprises.
 .
 This package ships development files.
