=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,16 @@
 if (TARGET competition-all)
   add_executable(distinctuseridcompetition distinctuseridcompetition.cpp)
   target_link_libraries(distinctuseridcompetition competition-core)
+
   add_executable(minifiercompetition minifiercompetition.cpp)
   target_link_libraries(minifiercompetition competition-core)
+
   add_executable(parseandstatcompetition parseandstatcompetition.cpp)
   target_link_libraries(parseandstatcompetition competition-core)
+
   add_executable(parsingcompetition parsingcompetition.cpp)
   target_link_libraries(parsingcompetition competition-core)
+
   add_executable(allparsingcompetition parsingcompetition.cpp)
   target_link_libraries(allparsingcompetition competition-all)
   target_compile_definitions(allparsingcompetition PRIVATE ALLPARSER)
@@ -40,6 +44,7 @@
   link_libraries(benchmark::benchmark)
   add_executable(bench_parse_call bench_parse_call.cpp)
   add_executable(bench_dom_api bench_dom_api.cpp)
+  add_executable(bench_ondemand bench_ondemand.cpp)
 endif()
 
 include(checkperf.cmake)
