=== dependencies/CMakeLists.txt ===
--- 
+++ 
@@ -67,8 +67,17 @@
     add_library(competition-ujson4c ujson4c/src/ujdecode.c)
     target_include_directories(competition-ujson4c PUBLIC ujson4c/3rdparty ujson4c/src)
 
+    initialize_submodule(boost.json)
+    add_library(boostjson boost.json/src/src.cpp)
+    target_compile_definitions(boostjson PUBLIC BOOST_JSON_STANDALONE)
+    target_include_directories(boostjson PUBLIC boost.json/include)
+
+    initialize_submodule(yyjson)
+    add_library(yyjson yyjson/src/yyjson.c)
+    target_include_directories(yyjson PUBLIC yyjson/src)
+
     add_library(competition-core INTERFACE)
-    target_link_libraries(competition-core INTERFACE competition-json competition-rapidjson competition-sajson competition-cJSON competition-jsmn)
+    target_link_libraries(competition-core INTERFACE competition-json competition-rapidjson competition-sajson competition-cJSON competition-jsmn boostjson yyjson)
 
     add_library(competition-all INTERFACE)
     target_link_libraries(competition-all INTERFACE competition-core competition-jsoncppdist competition-json11 competition-fastjson competition-gason competition-ujson4c)
@@ -81,7 +90,7 @@
 else()
   message(STATUS "Git is unavailable.")
   if(SIMDJSON_COMPETITION)
-    message (STATUS "'SIMDJSON_COMPETITION' is requested, but we cannot download the  remote repositories." )
+    message (STATUS "'SIMDJSON_COMPETITION' is requested, but we cannot download the remote repositories." )
   endif()
   if(SIMDJSON_GOOGLE_BENCHMARKS)
     message (STATUS "'SIMDJSON_GOOGLE_BENCHMARKS' is requested, but we cannot download the remote repositories." )
