=== debian/changelog ===
simdjson (0.6.1-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Downgrade debhelper compat to 12.
  * Purge the symbols control files.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Dec 2020 20:02:08 +0800

simdjson (0.6.1-2) unstable; urgency=medium

  * Refresh symbols control file for ppc64el and x32.
  * Change Architecture of the binary packages to "any".
  * Rename libsimdjson4.symbols -> libsimdjson4.symbols.amd64.

 -- Mo Zhou <lumin@debian.org>  Thu, 26 Nov 2020 14:32:01 +0800

simdjson (0.6.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 07 Nov 2020 12:20:13 +0800

simdjson (0.6.1-1~exp1) experimental; urgency=medium

  * New upstream version 0.6.1
  * Initialize foundamental autopkgtest control file.
  * Bump SOVERSION and update the description according to upstream.
  * Refresh symbols control file for amd64 and arm64.
  * Add ppc64el to supported architecture list.
  * Update d/copyright information.
  * Apply wrap-and-sort and make some trivial formatting changes.

 -- Mo Zhou <lumin@debian.org>  Wed, 04 Nov 2020 13:35:18 +0800
