=== debian/control ===
Source: simdjson
Section: libs
Homepage: https://github.com/lemire/simdjson
Priority: optional
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian/simdjson
Vcs-Git: https://salsa.debian.org/debian/simdjson.git
Maintainer: Mo Zhou <lumin@debian.org>
Build-Depends: cmake, debhelper-compat (= 12)
Rules-Requires-Root: no

Package: libsimdjson4
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Parsing gigabytes of JSON per second (shared object)
 JSON is everywhere on the Internet. Servers spend a *lot* of time parsing it.
 We need a fresh approach. The simdjson library uses commonly available SIMD
 instructions and microparallel algorithms to parse JSON 2.5x faster than
 RapidJSON and 25x faster than JSON for Modern C++.
 .
  * Fast: Over 2.5x faster than commonly used production-grade JSON parsers.
  * Record Breaking Features: Minify JSON at 6 GB/s, validate UTF-8 at 13 GB/s,
    NDJSON at 3.5 GB/s.
  * Easy: First-class, easy to use and carefully documented APIs.
  * Beyond DOM: Try the new On Demand API for twice the speed (>4GB/s).
  * Strict: Full JSON and UTF-8 validation, lossless parsing. Performance with
    no compromises.
  * Automatic: Selects a CPU-tailored parser at runtime.
    No configuration needed.
  * Reliable: From memory allocation to error handling, simdjson's design
    avoids surprises.
  * Peer Reviewed: Our research appears in venues like VLDB Journal,
    Software: Practice and Experience.
 .
 This package ships the shared object.

Package: libsimdjson-dev
Section: libdevel
Architecture: any
Depends: libsimdjson4 (= ${binary:Version}), ${misc:Depends}
Description: Parsing gigabytes of JSON per second (development)
 JSON is everywhere on the Internet. Servers spend a *lot* of time parsing it.
 We need a fresh approach. The simdjson library uses commonly available SIMD
 instructions and microparallel algorithms to parse JSON 2.5x faster than
 RapidJSON and 25x faster than JSON for Modern C++.
 .
  * Fast: Over 2.5x faster than commonly used production-grade JSON parsers.
  * Record Breaking Features: Minify JSON at 6 GB/s, validate UTF-8 at 13 GB/s,
    NDJSON at 3.5 GB/s.
  * Easy: First-class, easy to use and carefully documented APIs.
  * Beyond DOM: Try the new On Demand API for twice the speed (>4GB/s).
  * Strict: Full JSON and UTF-8 validation, lossless parsing. Performance with
    no compromises.
  * Automatic: Selects a CPU-tailored parser at runtime.
    No configuration needed.
  * Reliable: From memory allocation to error handling, simdjson's design
    avoids surprises.
  * Peer Reviewed: Our research appears in venues like VLDB Journal,
    Software: Practice and Experience.
 .
 This package ships development files.
