## simdjson 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.9) # CMP0069 NEW
+cmake_minimum_required(VERSION 3.13)
 
 project(simdjson
   DESCRIPTION "Parsing gigabytes of JSON per second"
@@ -6,11 +6,11 @@
 )
 
 set(PROJECT_VERSION_MAJOR 0)
-set(PROJECT_VERSION_MINOR 6)
-set(PROJECT_VERSION_PATCH 1)
-set(SIMDJSON_SEMANTIC_VERSION "0.6.1" CACHE STRING "simdjson semantic version")
-set(SIMDJSON_LIB_VERSION "4.0.0" CACHE STRING "simdjson library version")
-set(SIMDJSON_LIB_SOVERSION "4" CACHE STRING "simdjson library soversion")
+set(PROJECT_VERSION_MINOR 7)
+set(PROJECT_VERSION_PATCH 0)
+set(SIMDJSON_SEMANTIC_VERSION "0.7.0" CACHE STRING "simdjson semantic version")
+set(SIMDJSON_LIB_VERSION "5.0.0" CACHE STRING "simdjson library version")
+set(SIMDJSON_LIB_SOVERSION "5" CACHE STRING "simdjson library soversion")
 set(SIMDJSON_GITHUB_REPOSITORY https://github.com/simdjson/simdjson)
 
 include(GNUInstallDirs)
