=== debian/changelog ===
simdjson (0.7.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Tue, 08 Dec 2020 13:55:23 +0800

simdjson (0.7.0-1~exp1) experimental; urgency=medium

  * New upstream version 0.7.0
  * SOVERSION bump from 4 -> 5; rename packages accordingly.

 -- Mo Zhou <lumin@debian.org>  Sat, 05 Dec 2020 16:05:57 +0800
